/***************************************************************************
 ***        Programm zur Ansteuerung des Memodules                      ***
 ***                    MM-232.20                                        ***
 ***************************************************************************/
#include <math.h>

#include <stdio.h>           /* Prototypen fr Ein-Ausgabe */
#include <conio.h>
#include <dos.h>
#include <string.h>
#include <time.h>

void clear_screen(void);
void write_position(int x, int y, char *text, int attr);
void main_menu(void);
void mess_menu(void);
void error_win(char *text1,char *text2);
void input_win(char *text);
void install(void);
void konfig(void);
void interrupt timer_int(void);

void interrupt (*oldint)(void);

typedef char name[21];

int  key,messt=1;

int konfiguration[4];
int RS232=0x2F8;
int sw1=0,sw2=0;
char zeichen[10];
char dateiname[]="TEST.DAT";
char konfigname[]="MM232_20.CFG";
FILE *datei;
int timed=30;
volatile int timeout;

/************************************************************************
 ***                Hauptprogramm                                     ***
 ************************************************************************/

int main(void)
{
  int i;


  clear_screen();                       /* Bildschirm lschen           */
  _setcursortype(_NOCURSOR);            /* Cursor aus                   */
  /* Konfiguration laden */
  konfiguration[0]=10;
  konfiguration[1]=2;
  konfiguration[2]=0;
  konfiguration[3]=0;
  datei=fopen(konfigname,"rb");
  if(datei!=NULL)
    {
      konfiguration[0]=fgetc(datei);
      konfiguration[1]=fgetc(datei);
      konfiguration[2]=fgetc(datei);
      konfiguration[3]=fgetc(datei);
      fclose(datei);
    }
  if(konfiguration[1]==1)
	 RS232=0x3F8;
  if(konfiguration[1]==2)
	 RS232=0x2F8;
  if(konfiguration[1]==3)
	 RS232=0x3E8;
  if(konfiguration[1]==4)
	 RS232=0x2E8;
  main_menu();                          /* Bildschirmdarstellung        */
  key=0;                                /* Variable fr Taste initialisieren */
  do                                    /* in Schleife verharren        */
    {                                   /* bis Taste F1-3 oder F10 gedrckt */
      i=kbhit();
      if (i==-1)                        /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if (key==0)
	    key=getch();                /* Scan-Code holen              */
	  switch (key)
	    {
	      case 59:{                 /* Bei F1 : Konfigurieren       */
			konfig();
			main_menu();
			key=0;
			break;
		      }
	      case 60:{                 /* Bei F2 : Messen              */
			mess_menu();
			main_menu();
			key=0;
			break;
		      }
	    }
	}
    }
  while (key!=68);                      /* Wenn F10, dann ende          */

  textattr(0x07);
  clrscr();
  _setcursortype(_NORMALCURSOR);        /* Standardcursor an            */
  return 0;
}

/************************************************************************
 ***              Interruptroutine fr Timeout                        ***
 ************************************************************************/

void interrupt timer_int(void)
{
  timeout++;
  oldint();
}

/************************************************************************
 ***                Fr die RS232 - Schnittstelle                     ***
 ************************************************************************/

void install(void)
{
  outportb(RS232+3,0x80);
  outportb(RS232+1,0);
  outportb(RS232,12);
  outportb(RS232+3,0x03);
  outportb(RS232+1,0x00);
  outportb(RS232+4,0x0B);
  outportb(RS232+6,0x10);
  inportb(RS232);
  inportb(RS232);
  outportb(0x20,0x20);
  oldint=getvect(8);
  setvect(8,timer_int);
}

/************************************************************************
 ***                Mensteuerung                                     ***
 ************************************************************************/

void konfig_menu(void)
{
  char text1[]="  Konfigurieren des Programmes               ";
  char text2[]="  +/- = Merate einstellen       :      Sek. ";
  char text3[]="  F3  = Schnittstelle einstellen : COM       ";
  char text4[]="  F4  = Daten speichern ?        :           ";
  char text5[]="  F8  = Anzeige                  :           ";
  char text6[]="  F5  = Konfiguration speichern              ";
  char text7[]="%1d";
  char text8[]="%4d";
  char text9[]="  F10 =  ENDE                                ";
  int  x=20;
  int  y=13;

  clear_screen();
  write_position(x,y-2,text1,1);
  write_position(x,y  ,text2,1);
  write_position(x,y+1,text3,1);
  write_position(x,y+2,text4,1);
  write_position(x,y+3,text5,1);
  write_position(x,y+4,text6,1);
  write_position(x,y+6,text9,1);
  gotoxy(x+39,y+1);
  textattr(0x3F);
  cprintf(text7,konfiguration[1]);
  gotoxy(x+35,y);
  if(konfiguration[0]==0)
    write_position(x+35,y,"   Hand  ",1);
  else
    {
      cprintf(text8,konfiguration[0]);
      write_position(x+39,y," sek.",1);
    }
  textattr(0x3F);
  gotoxy(x+35,y+2);
  if(konfiguration[2]==1)
    cprintf(" Ja ");
  else
    cprintf("Nein");
  gotoxy(x+35,y+3);
  if(konfiguration[3]==1)
    cprintf("binr");
  else
    cprintf("Real ");
  textattr(0x3E);
}

/***************************************************************************/

void konfig(void)
{
  char text2[]="%1d";
  char text1[]="%4d";
  int i;
  int  x=20;
  int  y=13;

  konfig_menu();
  key=0;                                /* Variable fr Taste initialisieren */
  do                                    /* in Schleife verharren        */
    {                                   /* bis Taste F3-5 oder F10 gedrckt */
      i=kbhit();
      if (i==-1)                        /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if (key==0)
	    key=getch();                /* Scan-Code holen              */
	  switch (key)
	    {
	      case 43 : {
			  /* Messrate einstellen */
			  konfiguration[0]++;
			  if(konfiguration[0]==61)
			    konfiguration[0]=0;
			  textattr(0x3F);
			  gotoxy(x+35,y);
			  if(konfiguration[0]==0)
			    write_position(x+35,y,"   Hand  ",1);
			  else
			    {
			      cprintf(text1,konfiguration[0]);
			      write_position(x+39,y," sek.",1);
			    }
			  break;
			}
	      case 45 : {
			  /* Messrate einstellen */
			  konfiguration[0]--;
			  if(konfiguration[0]<0)
			    konfiguration[0]=60;
			  textattr(0x3F);
			  gotoxy(x+35,y);
			  if(konfiguration[0]==0)
			    write_position(x+35,y,"   Hand  ",1);
			  else
			    {
			      cprintf(text1,konfiguration[0]);
			      write_position(x+39,y," sek.",1);
			    }
			  break;
			}
	      case 61 : {
			  /* Schnittstelle einstellen */
			  if(konfiguration[1]==1)
			    {
			      konfiguration[1]=2;
			      RS232=0x2F8;
			      gotoxy(x+39,y+1);
			      textattr(0x3F);
			      cprintf(text2,konfiguration[1]);
			    }
			  else
			    if(konfiguration[1]==2)
			      {
				konfiguration[1]=3;
				RS232=0x3E8;
				gotoxy(x+39,y+1);
				textattr(0x3F);
				cprintf(text2,konfiguration[1]);
			      }
			    else
			      if(konfiguration[1]==3)
				{
				  konfiguration[1]=4;
				  RS232=0x2E8;
				  gotoxy(x+39,y+1);
				  textattr(0x3F);
				  cprintf(text2,konfiguration[1]);
				}
			      else
				if(konfiguration[1]==4)
				  {
				    konfiguration[1]=1;
				    RS232=0x3F8;
				    gotoxy(x+39,y+1);
				    textattr(0x3F);
				    cprintf(text2,konfiguration[1]);
				  }
			  break;
			}
	      case 62 : {
			  /* Whlbar abspeichern */
			  if(konfiguration[2]==0)
			    konfiguration[2]=1;
			  else
			    konfiguration[2]=0;
			  textattr(0x3F);
			  gotoxy(x+35,y+2);
			  if(konfiguration[2]==1)
			    cprintf(" Ja ");
			  else
			    cprintf("Nein");
			  break;
			}
	      case 63 : {
			  /* Konfiguration speichern */
			  datei=fopen(konfigname,"wb");
			  if(datei!=NULL)
			    {
			      fputc(konfiguration[0],datei);
			      fputc(konfiguration[1],datei);
			      fputc(konfiguration[2],datei);
			      fputc(konfiguration[3],datei);
			      fclose(datei);
			    }
			  break;
			}
	      case 66 : {
			  /* Anzeigeart ndern */
			  if(konfiguration[3]==0)
			    konfiguration[3]=1;
			  else
			    konfiguration[3]=0;
			  textattr(0x3F);
			  gotoxy(x+35,y+3);
			  if(konfiguration[3]==1)
			    cprintf("binr");
			  else
			    cprintf("Real ");
			  break;
			}
		 }
	}
    }
  while (key!=68);                      /* Wenn F10, dann ende          */

}

/************************************************************************/

void mess_menu(void)
{
  int z;
  char text1[]="ͻ";
  char text2[]="                                                      ";
  char text3[]="ͼ";
  char text4[]="";
  char text5[]="  Kanal 1                 :                     ";
  char text6[]="  Kanal 2                 :                     ";
  char text7[]="  Kanal 3                 :                     ";
  char text8[]="  Kanal 4                 :                     ";
  char text9[]="  Digitaleingang   1      :                     ";
  char text10[]="  Digitaleingang   2      :                    ";
  char text11[]="  Digitalausgang   1      :                (F6)";
  char text12[]="  Digitalausgang   2      :                (F7)";
  char text13[]="       Beenden der Messungen durch die Taste F 10     ";

  int x=14;
  int y=8;
  char test1;
  int time1=2;
  time_t zeit,soll;
  int time2=1;
  int aus1,aus2;
  int wert1,wert2,wert3,wert4;
  int save_dat=0;

  clear_screen();
  install();
  if(konfiguration[2]==1)
    {
      datei=fopen(dateiname,"ab");
      if(datei!=NULL)
	{
	  fprintf(datei,"Ŀ\n\r");
	  fprintf(datei,"  CH1   CH2   CH3   CH4  IN1  IN2  OUT1 OUT2\n\r");
	  fprintf(datei,"Ĵ\n\r");
	}
    }
  sw1=0;
  sw2=0;
  /* Kommando ausgeben */
  outportb(RS232+4,2);
  delay(100);
  while((inportb(RS232+5) & 64)==0);
  delay(time2);
  outportb(RS232,'$');
  while((inportb(RS232+5) & 64)==0);
  delay(time2);
  outportb(RS232,'O');
  while((inportb(RS232+5) & 64)==0);
  delay(time2);
  outportb(RS232,'F');
  while((inportb(RS232+5) & 64)==0);
  delay(time2);
  outportb(RS232,'1');
  /* Kommando ausgeben */
  delay(time1);
  while((inportb(RS232+5) & 64)==0);
  delay(time2);
  outportb(RS232,'$');
  while((inportb(RS232+5) & 64)==0);
  delay(time2);
  outportb(RS232,'O');
  while((inportb(RS232+5) & 64)==0);
  delay(time2);
  outportb(RS232,'F');
  while((inportb(RS232+5) & 64)==0);
  delay(time2);
  outportb(RS232,'2');

  /* Erzeugen eines Fensters */
  gotoxy(x,y);
  textattr(0x7F);
  cprintf(text1);
  for(z=0;z<11;z++)
    {
      gotoxy(x,y+z+1);
      cprintf(text2);
    }
  textattr(0x70);
  gotoxy(x+5,y+2);
  cprintf(text5);
  gotoxy(x+5,y+3);
  cprintf(text6);
  gotoxy(x+5,y+4);
  cprintf(text7);
  gotoxy(x+5,y+5);
  cprintf(text8);
  gotoxy(x+5,y+7);
  cprintf(text9);
  gotoxy(x+5,y+8);
  cprintf(text10);
  gotoxy(x+5,y+10);
  cprintf(text11);
  gotoxy(x+5,y+11);
  cprintf(text12);
  textattr(0x7F);
  gotoxy(x,y+12);
  cprintf(text2);
  gotoxy(x,y+13);
  cprintf(text2);
  gotoxy(x,y+14);
  cprintf(text3);
  textattr(0x70);
  gotoxy(x+1,y+15);
  cprintf(text4);
  for (z=0;z<14;z++)
    {
      gotoxy(x+56,y+1+z);
      cprintf("");
    }
  textattr(0x13);
  gotoxy(x+1,y+13);
  cprintf(text13);
  textattr(0x74);
  gotoxy(x+34,y+10);
  cprintf("AUS");
  gotoxy(x+34,y+11);
  cprintf("AUS");
  zeit=time(NULL);
  soll=zeit-1;
  z=0;
  do
    {
      if(konfiguration[0]!=0)
	zeit=time(NULL);
      if((zeit>soll) || ((konfiguration[0]==0) && kbhit()))
	{
	  if(konfiguration[0]!=0)
	    soll=zeit+konfiguration[0];
	  else
	    getch();
	  save_dat=1;
	  /* Daten lesen */
	  /* Kanle einlesen */
	  textattr(0x74);
	  delay(time1);
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'$');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'C');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'H');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'1');
	  z=0;
	  timeout=0;
	  do
		{
		  outportb(RS232+4,3);
		  test1=inportb(RS232+5);
		  outportb(RS232+4,2);
		  if((test1 & 1)==1)
		{
		  zeichen[z]=inportb(RS232);
		  timeout=0;
		  z++;
		}
		}
	  while((zeichen[z-1]!=10) && (timeout<timed));
	  /* Auswertung */
	  if((zeichen[4]==13) && (zeichen[5]==10) && (timeout<timed))
		{
		  wert1=0;
		  if(zeichen[0] != '=')
		  {
		for(z=0;z<4;z++)
		  {
			wert1*=10;
			wert1+=zeichen[z]-'0';
		  }
		textattr(0x74);
		gotoxy(x+34,y+2);
		if(konfiguration[3]==0)
		  cprintf("%4.2f V",(float)(wert1)*5/2000);
		else
		  cprintf("%4d   ",wert1);
		  }
		  else
		  {
		textattr(0x70);
		gotoxy(x+34,y+2);
		cprintf("====  ");
		  }
		}
	  else
		{
		  textattr(0x70);
		  gotoxy(x+34,y+2);
		  cprintf("----  ");
		  wert1=-1;
		}
	  delay(time1);
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'$');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'C');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'H');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'2');
	  z=0;
	  timeout=0;
	  do
	{
	  outportb(RS232+4,3);
	  test1=inportb(RS232+5);
	  outportb(RS232+4,2);
	  if((test1 & 1)==1)
		{
		  zeichen[z]=inportb(RS232);
		  timeout=0;
		  z++;
		}
	}
	  while((zeichen[z-1]!=10) && (timeout<timed));
	  /* Auswertung */
	  if((zeichen[4]==13) && (zeichen[5]==10) && (timeout<timed))
	{
	  wert2=0;
	  if(zeichen[0] != '=')
	  {
		for(z=0;z<4;z++)
		{
		  wert2*=10;
		  wert2+=zeichen[z]-'0';
		}
		textattr(0x74);
		gotoxy(x+34,y+3);
		if(konfiguration[3]==0)
		  cprintf("%4.2f V",(float)(wert2)*5/2000);
		else
		  cprintf("%4d   ",wert2);
	  }
	  else
	  {
		textattr(0x70);
		gotoxy(x+34,y+3);
		cprintf("====  ");
	  }
	}
	  else
	{
	  textattr(0x70);
	  gotoxy(x+34,y+3);
	  cprintf("----  ");
	  wert2=-1;
	}
	  delay(time1);
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'$');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'C');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'H');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'3');
	  z=0;
	  timeout=0;
	  do
	{
	  outportb(RS232+4,3);
	  test1=inportb(RS232+5);
	  outportb(RS232+4,2);
	  if((test1 & 1)==1)
		{
		  zeichen[z]=inportb(RS232);
		  timeout=0;
		  z++;
		}
	}
	  while((zeichen[z-1]!=10) && (timeout<timed));
	  /* Auswertung */
	  if((zeichen[4]==13) && (zeichen[5]==10) && (timeout<timed))
	{
	  wert3=0;
	  if(zeichen[0] != '=')
	  {
		for(z=0;z<4;z++)
		{
		  wert3*=10;
		  wert3+=zeichen[z]-'0';
		}
		textattr(0x74);
		gotoxy(x+34,y+4);
		if(konfiguration[3]==0)
		  cprintf("%4.2f V",(float)(wert3)*5/2000);
		else
		  cprintf("%4d   ",wert3);
	  }
	  else
	  {
		textattr(0x70);
		gotoxy(x+34,y+4);
		cprintf("====  ");
	  }
	}
	  else
	{
	  textattr(0x70);
	  gotoxy(x+34,y+4);
	  cprintf("----  ");
	  wert3=-1;
	}
	  delay(time1);
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'$');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'C');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'H');
	  while((inportb(RS232+5) & 64)==0);
	  delay(time2);
	  outportb(RS232,'4');
	  z=0;
	  timeout=0;
	  do
	{
	  outportb(RS232+4,3);
	  test1=inportb(RS232+5);
	  outportb(RS232+4,2);
	  if((test1 & 1)==1)
	    {
	      zeichen[z]=inportb(RS232);
	      timeout=0;
	      z++;
	    }
	}
      while((zeichen[z-1]!=10) && (timeout<timed));
      /* Auswertung */
      if((zeichen[4]==13) && (zeichen[5]==10) && (timeout<timed))
	{
	  wert4=0;
	  if(zeichen[0] != '=')
	  {
	    for(z=0;z<4;z++)
	    {
	      wert4*=10;
	      wert4+=zeichen[z]-'0';
	    }
	    textattr(0x74);
	    gotoxy(x+34,y+5);
	    if(konfiguration[3]==0)
	      cprintf("%4.2f V",(float)(wert4)*5/2000);
	    else
	      cprintf("%4d   ",wert4);
	  }
	  else
	  {
	    textattr(0x70);
	    gotoxy(x+34,y+5);
	    cprintf("====  ");
	  }
	}
      else
	{
	  textattr(0x70);
	  gotoxy(x+34,y+5);
	  cprintf("----  ");
	  wert4=-1;
	}
      /* Digitale Eingnge lesen */
      delay(time1);
      while((inportb(RS232+5) & 64)==0);
      delay(time2);
      outportb(RS232,'$');
      while((inportb(RS232+5) & 64)==0);
      delay(time2);
      outportb(RS232,'I');
      while((inportb(RS232+5) & 64)==0);
      delay(time2);
      outportb(RS232,'N');
      while((inportb(RS232+5) & 64)==0);
      delay(time2);
      outportb(RS232,'1');
      z=0;
      timeout=0;
      do
	{
	  outportb(RS232+4,3);
	  test1=inportb(RS232+5);
	  outportb(RS232+4,2);
	  if((test1 & 1)==1)
	    {
	      zeichen[z]=inportb(RS232);
	      timeout=0;
	      z++;
	    }
	}
      while((zeichen[z-1]!=10) && (timeout<timed));
      if(((zeichen[0]=='*') && (zeichen[1]=='0')) || ((zeichen[0]=='*') && (zeichen[1]=='1')) && (timeout<timed))
	{
	  aus1=zeichen[1];
	  gotoxy(x+34,y+7);
	  if(aus1=='1')
	    {
	      textattr(0x7E);
	      cprintf("AN ");
	    }
	  else
	    {
	      textattr(0x74);
	      cprintf("AUS");
	    }
	}
      else
	{
	  textattr(0x70);
	  gotoxy(x+34,y+7);
	  cprintf("---");
	  aus1='-';
	}
      delay(time1);
      while((inportb(RS232+5) & 64)==0);
      delay(time2);
      outportb(RS232,'$');
      while((inportb(RS232+5) & 64)==0);
      delay(time2);
      outportb(RS232,'I');
      while((inportb(RS232+5) & 64)==0);
      delay(time2);
      outportb(RS232,'N');
      while((inportb(RS232+5) & 64)==0);
      delay(time2);
      outportb(RS232,'2');
      z=0;
      timeout=0;
      do
	{
	  outportb(RS232+4,3);
	  test1=inportb(RS232+5);
	  outportb(RS232+4,2);
	  if((test1 & 1)==1)
	    {
	      zeichen[z]=inportb(RS232);
	      timeout=0;
	      z++;
	    }
	}
      while((zeichen[z-1]!=10) && (timeout<timed));
      if(((zeichen[0]=='*') && (zeichen[1]=='0')) || ((zeichen[0]=='*') && (zeichen[1]=='1')) && (timeout<timed))
	{
	  aus2=zeichen[1];
	  gotoxy(x+34,y+8);
	  if(aus2=='1')
	    {
	      textattr(0x7E);
	      cprintf("AN ");
	    }
	  else
	    {
	      textattr(0x74);
	      cprintf("AUS");
	    }
	}
      else
	{
	  textattr(0x70);
	  gotoxy(x+34,y+8);
	  cprintf("---");
	  aus2='-';
	}
      }

      /* Warten auf Tastendruck */
      if(kbhit())
	{
	  key=getch();
	  if(key==0)
	    key=getch();
	  /* Reaktion auf Tasten F6 und F7 */
	  if(key==64)
	    {
	      sw1^=1;
	      gotoxy(x+34,y+10);
	      if(sw1==1)
		{
		  textattr(0x7E);
		  cprintf("AN ");
		}
	      else
		{
		  textattr(0x74);
		  cprintf("AUS");
		}
	      /* Kommando ausgeben */
	      while((inportb(RS232+5) & 64)==0);
	      delay(time2);
	      outportb(RS232,'$');
	      while((inportb(RS232+5) & 64)==0);
	      delay(time2);
	      outportb(RS232,'O');
	      while((inportb(RS232+5) & 64)==0);
	      delay(time2);
	      if(sw1==1)
		outportb(RS232,'N');
	      else
		outportb(RS232,'F');
	      while((inportb(RS232+5) & 64)==0);
	      delay(time2);
	      outportb(RS232,'1');
	      key=0;
	    }
	  else
	    if(key==65)
	      {
		sw2^=1;
		gotoxy(x+34,y+11);
		if(sw2==1)
		  {
		    textattr(0x7E);
		    cprintf("AN ");
		  }
		else
		  {
		    textattr(0x74);
		    cprintf("AUS");
		  }
		/* Kommando ausgeben */
		while((inportb(RS232+5) & 64)==0);
		delay(time2);
		outportb(RS232,'$');
		while((inportb(RS232+5) & 64)==0);
		delay(time2);
		outportb(RS232,'O');
		while((inportb(RS232+5) & 64)==0);
		delay(time2);
		if(sw2==1)
		  outportb(RS232,'N');
		else
		  outportb(RS232,'F');
		while((inportb(RS232+5) & 64)==0);
		delay(time2);
		outportb(RS232,'2');
		key=0;
	      }
	}
      /* Speichern */
      if((save_dat==1) && (datei!=NULL) && (konfiguration[2]==1))
	{
	  save_dat=0;
	  if(konfiguration[3]==0)
	    {
	    fprintf(datei," %4.2f ",(float)(wert1)*5/2000);
	    fprintf(datei," %4.2f ",(float)(wert2)*5/2000);
	    fprintf(datei," %4.2f ",(float)(wert3)*5/2000);
	    fprintf(datei," %4.2f ",(float)(wert4)*5/2000);
	    }
	  else
	    fprintf(datei," %4d  %4d  %4d  %4d ",wert1,wert2,wert3,wert4);
	  if(aus1=='1')
	    fprintf(datei," AN  ");
	  else
	    if(aus1=='0')
	      fprintf(datei," AUS ");
	    else
	      fprintf(datei," --- ");
	  if(aus2=='1')
	    fprintf(datei," AN  ");
	  else
	    if(aus2=='0')
	      fprintf(datei," AUS ");
	    else
	      fprintf(datei," --- ");
	  if(sw1==1)
	    fprintf(datei," AN  ");
	  else
	    fprintf(datei," AUS ");
	  if(sw2==1)
	    fprintf(datei," AN  \n\r");
	  else
	    fprintf(datei," AUS \n\r");
	}
    }
  while(key!=68);
  if(konfiguration[2]==1)
    {
      if(datei!=NULL)
	{
	  fprintf(datei,"\n\r");
	  fclose(datei);
	}
    }
  setvect(8,oldint);
  key=0;

}

/************************************************************************/

void main_menu(void)
{
  char text1[]=" Programm zum Einlesen der  ";
  char text2[]=" Mewerte eines Memodules  ";
  char text3[]="     F1  = Konfigurieren    ";
  char text4[]="     F2  = Messen           ";
  char text5[]="     F10 =  ENDE            ";
  int  x=25;
  int  y=13;

  clear_screen();
  write_position(x,y-3,text1,1);
  write_position(x,y-2,text2,1);
  write_position(x,y  ,text3,1);
  write_position(x,y+1,text4,1);
  write_position(x,y+3,text5,1);
}

/************************************************************************
 ***                Unterprogramme zur Bildschirmsteuerung            ***
 ************************************************************************/

void clear_screen(void)
{
  /* Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
     Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
     Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.  */

  char rahm1[]="ͻ";
  char rahm2[]="                                                         ";
  char rahm3[]="ͼ";
  char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen";
  char text2[]="      Tel. 07462/7381               Fax 07462/7554       ";
  char text3[]="";

  textbackground(BLUE);                 /* Hintergrundfarbe schwarz     */
  textcolor(CYAN);                      /* Vordergrundfarbe hellgrau    */
  clrscr();                             /* Bildschirm lschen           */

  /* Erzeugen eines Fensters */
  gotoxy(12,2);
  textattr(0x7F);
  cprintf(rahm1);
  gotoxy(12,3);
  cprintf(rahm2);
  gotoxy(12,4);
  cprintf(rahm2);
  gotoxy(12,5);
  cprintf(rahm3);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(13,3);
  cprintf(text1);
  gotoxy(13,4);
  cprintf(text2);
  /* Erzeugen des Fensterschattens */
  gotoxy(13,6);
  cprintf(text3);
  gotoxy(71,3);
  cprintf("");
  gotoxy(71,4);
  cprintf("");
  gotoxy(71,5);
  cprintf("");
  textattr(0x03);
}

/***************************************************************************/

void write_position(int x,int y,char *text,int attr)
{
  if (attr==0)
    textattr(0x10);
  if (attr==1)
    textattr(0x3E);
  gotoxy(x,y);
  cprintf(text);

}
